VERSION 5.00
Begin VB.UserControl CustomButton 
   ClientHeight    =   675
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1365
   PropertyPages   =   "CustomButton.ctx":0000
   ScaleHeight     =   675
   ScaleWidth      =   1365
   ToolboxBitmap   =   "CustomButton.ctx":0014
   Begin VB.Timer Timer1 
      Interval        =   250
      Left            =   90
      Top             =   105
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Label"
      Height          =   195
      Left            =   570
      TabIndex        =   0
      Top             =   180
      Width           =   405
   End
   Begin VB.Line Left 
      BorderColor     =   &H80000014&
      BorderWidth     =   2
      X1              =   15
      X2              =   15
      Y1              =   15
      Y2              =   615
   End
   Begin VB.Line Bottom 
      BorderColor     =   &H80000015&
      BorderWidth     =   2
      X1              =   15
      X2              =   1230
      Y1              =   615
      Y2              =   615
   End
   Begin VB.Line Right 
      BorderColor     =   &H80000015&
      BorderWidth     =   2
      X1              =   1260
      X2              =   1260
      Y1              =   15
      Y2              =   615
   End
   Begin VB.Line Top 
      BorderColor     =   &H80000014&
      BorderWidth     =   2
      X1              =   15
      X2              =   1245
      Y1              =   15
      Y2              =   15
   End
End
Attribute VB_Name = "CustomButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private ButtonLighted As Boolean
Private mButtonMode As ButtonModeTypes
Private mCursorPos As POINTAPI
Private mBorderStyle As BorderStyles

Private mBackColor As OLE_COLOR
Private mBackSelColor As OLE_COLOR

Private mFont As StdFont
Private mFontColor As OLE_COLOR
Private mFontSelColor As OLE_COLOR

Private mPicture As StdPicture
Private mSelPicture As StdPicture

Private mHighLightColor As OLE_COLOR
Private mShadowColor As OLE_COLOR

Public Enum ButtonModeTypes
    [Text Mode] = 0
    [Image Mode] = 1
End Enum

Public Enum BorderStyles
    None = 0
    Inset = 1
    Raised = 2
End Enum

Public Event StatusChanged(NewStatus As Integer)
Attribute StatusChanged.VB_Description = "Triggered if the control's status changes form selected to unselected, or vice versa."
Attribute StatusChanged.VB_MemberFlags = "40"
Public Event Click()
Public Event DblClick()
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)


Private Sub Timer1_Timer()
    Dim Status As Long
    Dim CurrenthWnd As Long
    
    Timer1.Enabled = False
    
    Status = GetCursorPos&(mCursorPos)
    CurrenthWnd = WindowFromPoint(mCursorPos.X, mCursorPos.Y)
    
    If ButtonLighted = False Then
        If CurrenthWnd = UserControl.hWnd Then
            ButtonLighted = True
            If mButtonMode = [Text Mode] Then
                UserControl.BackColor = mBackSelColor
                Label1.ForeColor = mFontSelColor
            Else
                Set UserControl.Picture = mSelPicture
            End If
            RaiseEvent StatusChanged(1)
        End If
    Else
        If CurrenthWnd <> UserControl.hWnd Then
            ButtonLighted = False
            If mButtonMode = [Text Mode] Then
                Label1.ForeColor = mFontColor
                UserControl.BackColor = mBackColor
            Else
                Set UserControl.Picture = mPicture
            End If
            RaiseEvent StatusChanged(0)
        End If
    End If
    
    Timer1.Enabled = True
    
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
    
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
    
End Sub

Private Sub UserControl_Initialize()
    ButtonLighted = False
    RaiseEvent StatusChanged(0)
    mBackColor = UserControl.BackColor
    
End Sub

Private Sub UserControl_InitProperties()
    Timer1.Enabled = Ambient.UserMode
    Label1.Caption = Ambient.DisplayName
    mBackSelColor = &H800000
    mFontSelColor = &HFFFFFF
    mHighLightColor = vb3DHighlight
    mShadowColor = vb3DDKShadow
    ButtonMode = [Text Mode]
    BorderStyle = Raised

End Sub


Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
    
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
    
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
    
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
    
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    
End Sub

Private Sub UserControl_Resize()
    
    Top.X1 = UserControl.ScaleLeft + 15
    Top.X2 = UserControl.ScaleWidth
    Top.Y1 = UserControl.ScaleTop + 15
    Top.Y2 = UserControl.ScaleTop + 15
    
    Left.X1 = UserControl.ScaleLeft + 15
    Left.X2 = UserControl.ScaleLeft + 15
    Left.Y1 = UserControl.ScaleTop + 15
    Left.Y2 = UserControl.ScaleHeight - 30
    
    Bottom.X1 = UserControl.ScaleLeft + 30
    Bottom.X2 = UserControl.ScaleWidth
    Bottom.Y1 = UserControl.ScaleHeight - 15
    Bottom.Y2 = UserControl.ScaleHeight - 15
    
    Right.X1 = UserControl.ScaleWidth - 15
    Right.X2 = UserControl.ScaleWidth - 15
    Right.Y1 = UserControl.ScaleTop + 30
    Right.Y2 = UserControl.ScaleHeight - 15
    
    Label1.Left = (UserControl.Width - Label1.Width) / 2
    Label1.Top = (UserControl.Height - Label1.Height) / 2
    
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Timer1.Enabled = Ambient.UserMode
    
    Caption = PropBag.ReadProperty("Caption", Ambient.DisplayName)
    BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
    ButtonMode = PropBag.ReadProperty("ButtonMode", 0)
    FontColor = PropBag.ReadProperty("FontColor", mFontColor)
    FontSelColor = PropBag.ReadProperty("FontSelColor", &HFFFFFF)
    BackSelColor = PropBag.ReadProperty("BackSelColor", &H800000)
    EdgeHighLight = PropBag.ReadProperty("EdgeHighLight", vb3DHighlight)
    EdgeShadow = PropBag.ReadProperty("EdgeShadow", vb3DDKShadow)
    BorderStyle = PropBag.ReadProperty("BorderStyle", 2) 'raised border
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    Set SelPicture = PropBag.ReadProperty("SelPicture", Nothing)
    Set Font = PropBag.ReadProperty("Font", mFont)
    Enabled = PropBag.ReadProperty("Enabled", True)
    
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Caption", Caption, Ambient.DisplayName
    PropBag.WriteProperty "Font", Font, mFont
    PropBag.WriteProperty "BackColor", BackColor, vbButtonFace
    PropBag.WriteProperty "ButtonMode", ButtonMode, 0
    PropBag.WriteProperty "FontColor", FontColor, mFontColor
    PropBag.WriteProperty "FontSelColor", FontSelColor, &HFFFFFF
    PropBag.WriteProperty "BackSelColor", BackSelColor, vbBlue
    PropBag.WriteProperty "EdgeHighLight", EdgeHighLight, vb3DHighlight
    PropBag.WriteProperty "EdgeShadow", EdgeShadow, vb3DDKShadow
    PropBag.WriteProperty "BorderStyle", BorderStyle, 2
    PropBag.WriteProperty "Picture", Picture, Nothing
    PropBag.WriteProperty "SelPicture", SelPicture, Nothing
    PropBag.WriteProperty "Enabled", Enabled, True
    
End Sub


Public Property Get Caption() As String
Attribute Caption.VB_Description = "Sets or changes the controls text. Used only in ""Text Mode"""
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Caption = Label1.Caption
    
End Property

Public Property Let Caption(ByVal vNewValue As String)
    Label1.Caption = vNewValue
    UserControl.PropertyChanged "Caption"
    
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Changes the controls backcolor. Used only if the control is in ""Text Mode"""
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BackColor = UserControl.BackColor
    
End Property

Public Property Let BackColor(ByVal vNewValue As OLE_COLOR)
    UserControl.BackColor = vNewValue
    UserControl.PropertyChanged "BackColor"
    mBackColor = vNewValue
    
End Property

Public Property Get ButtonMode() As ButtonModeTypes
Attribute ButtonMode.VB_Description = "Determines if how the control will function. Uses the BackSelColor in ""Text Mode"" and SelPicture in ""Image Mode"""
Attribute ButtonMode.VB_ProcData.VB_Invoke_Property = ";Behavior"
    ButtonMode = mButtonMode
    
End Property

Public Property Let ButtonMode(ByVal vNewValue As ButtonModeTypes)
    If vNewValue = [Text Mode] Or vNewValue = [Image Mode] Then
        mButtonMode = vNewValue
        
        If mButtonMode = [Text Mode] Then Label1.Visible = True
        If mButtonMode = [Image Mode] Then Label1.Visible = False
        
        UserControl.PropertyChanged "ButtonMode"
    Else
        Err.Raise Number:=vbObjectError + 32113, Description:="Invalid ButtonMode value (0 or 1 only)"
    End If
    
End Property

Public Property Get BorderStyle() As BorderStyles
Attribute BorderStyle.VB_Description = "Changes the appearance of the Border of the control."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BorderStyle = mBorderStyle
    
End Property

Public Property Let BorderStyle(ByVal vNewValue As BorderStyles)
    If vNewValue = None Or vNewValue = Inset Or vNewValue = Raised Then
        mBorderStyle = vNewValue
        UserControl.PropertyChanged "BorderStyle"
        Call SetBorder
    Else
        Err.Raise Number:=vbObjectError + 32114, Description:="Invalid BorderStyle value (0, 1 or 2 only)"
    End If
    
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
    Set Font = Label1.Font
        
End Property

Public Property Set Font(ByVal vNewValue As StdFont)
    Set Label1.Font = vNewValue
    UserControl.PropertyChanged "Font"
    Call UserControl_Resize
    
End Property

Public Property Get FontColor() As OLE_COLOR
Attribute FontColor.VB_Description = "Sets the color used for the text."
Attribute FontColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FontColor = Label1.ForeColor
    
End Property

Public Property Let FontColor(ByVal vNewValue As OLE_COLOR)
    Label1.ForeColor = vNewValue
    UserControl.PropertyChanged "FontColor"
    mFontColor = vNewValue
    
End Property

Public Property Get FontSelColor() As OLE_COLOR
Attribute FontSelColor.VB_Description = "Sets the color of the text when the control is ""selected""."
Attribute FontSelColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FontSelColor = mFontSelColor
    
End Property

Public Property Let FontSelColor(ByVal vNewValue As OLE_COLOR)
    mFontSelColor = vNewValue
    UserControl.PropertyChanged "FontSelColor"
    
End Property

Public Property Get BackSelColor() As OLE_COLOR
Attribute BackSelColor.VB_Description = "Changes the controls ""Selected"" color. Used only if in ""Text Mode"""
Attribute BackSelColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BackSelColor = mBackSelColor
    
End Property

Public Property Let BackSelColor(ByVal vNewValue As OLE_COLOR)
    mBackSelColor = vNewValue
    UserControl.PropertyChanged "BackSelColor"
    
End Property

Public Property Get EdgeHighLight() As OLE_COLOR
Attribute EdgeHighLight.VB_Description = "Sets the light color of the border."
Attribute EdgeHighLight.VB_ProcData.VB_Invoke_Property = ";Appearance"
    EdgeHighLight = mHighLightColor
    
End Property

Public Property Let EdgeHighLight(ByVal vNewValue As OLE_COLOR)
    mHighLightColor = vNewValue
    UserControl.PropertyChanged "EdgeHighLight"
    Call UserControl_Resize
    
End Property

Public Property Get EdgeShadow() As OLE_COLOR
Attribute EdgeShadow.VB_Description = "Sets the dark color of the border."
Attribute EdgeShadow.VB_ProcData.VB_Invoke_Property = ";Appearance"
    EdgeShadow = mShadowColor
    
End Property

Public Property Let EdgeShadow(ByVal vNewValue As OLE_COLOR)
    mShadowColor = vNewValue
    UserControl.PropertyChanged "EdgeShadow"
    Call UserControl_Resize
    
End Property

Public Property Get Picture() As StdPicture
Attribute Picture.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Set Picture = UserControl.Picture
    
End Property

Public Property Set Picture(ByVal vNewValue As StdPicture)
    Set UserControl.Picture = vNewValue
    Set mPicture = vNewValue
    
    If vNewValue Is Nothing Then
        ButtonMode = [Text Mode]
    Else
        ButtonMode = [Image Mode]
    End If
    UserControl.PropertyChanged "Picture"
    
End Property

Public Property Get SelPicture() As StdPicture
Attribute SelPicture.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Set SelPicture = mSelPicture
    
End Property

Public Property Set SelPicture(ByVal vNewValue As StdPicture)
    Set mSelPicture = vNewValue
    UserControl.PropertyChanged "SelPicture"
    
End Property

Public Property Get Enabled() As Variant
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Enabled = UserControl.Enabled
    
End Property

Public Property Let Enabled(ByVal vNewValue As Variant)
    UserControl.Enabled = vNewValue
    UserControl.PropertyChanged "Enabled"
    
End Property

Private Sub SetBorder()

    Select Case mBorderStyle
        Case 0
            ' no border
            Top.Visible = False
            Left.Visible = False
            Bottom.Visible = False
            Right.Visible = False
            
        Case 1
            Top.Visible = True
            Left.Visible = True
            Bottom.Visible = True
            Right.Visible = True
        
            'inset border
            Top.BorderColor = mShadowColor
            Left.BorderColor = Top.BorderColor
            Bottom.BorderColor = mHighLightColor
            Right.BorderColor = Bottom.BorderColor
            
        Case 2
            Top.Visible = True
            Left.Visible = True
            Bottom.Visible = True
            Right.Visible = True
            'raised border
            Top.BorderColor = mHighLightColor
            Left.BorderColor = Top.BorderColor
            Bottom.BorderColor = mShadowColor
            Right.BorderColor = Bottom.BorderColor
    End Select
    Call UserControl_Resize
    
End Sub

Public Sub Refresh()
    UserControl.Refresh
    
End Sub

